unit musicBar0;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type TWaveColor = (PEN, LEVEL, BACKGROUND);


type
  TMusicWave = class
  private
    mHeight, mWidth, mPt, prev, mX, mY, dx: integer;
    mLevel: integer;
     //float *pt;
     //static int test;
    toLeft, reset, mShowLevel: boolean;
    mPenColor, mLevelColor, mBackColor: TColor;
  public
    procedure MusicWave(width, height: integer);
    procedure setColor(wcType: TWaveColor; color: TColor);
    procedure setDirection(lft: boolean);
    procedure setSize(canvas: TCanvas; width, height: integer);
    procedure showLevel(level: integer);
    procedure hideLevel();
    procedure showWave(canvas: TCanvas; x, y, value: integer);
  end;


type
  TMusicBar = class
  private
    mHeight, mWidth, mLevel, down, top: integer;
     //static int test;
    mColor: array[0..4] of TColor;
  public
    procedure MusicBar( width,  height:integer);
    procedure setSize(width, height: integer);
    procedure showBar(canvas: TCanvas; px, py, value: integer);
  end;


{
TColor MusicBar.mColor[]:=begin clLime, clYellow, clFuchsia, clRed end;;
/* below codes seem fine but error occur.
TColor MusicBar.mColor[1]:=clGreen;
TColor MusicBar.mColor[2]:=clRed;
TColor MusicBar.mColor[3]:=clRed;
*/
}
type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const BarNo = 20;
var
  Form1: TForm1;
  mbar: array[0..BarNo] of TMusicBar;
  mwave: TMusicWave; //(200, 50)

implementation

{$R *.dfm}

procedure TMusicWave.hideLevel;
begin
  mShowLevel:=false;
end;

procedure TMusicWave.MusicWave(width, height: integer);
begin
  //width := 50;  height := 50;  //initializatoin

  mWidth := width;
  mHeight := height;
  mPt := 0; dx := 3;
  mLevel := 0;
  toLeft := true; mShowLevel := false;
  mPenColor := clYellow; mLevelColor := clLime; mBackColor := clBlack;

end;

procedure TMusicWave.setColor(wcType: TWaveColor; color: TColor);
begin
  case (wcType) of
    PEN:
      mPenColor := color;
    LEVEL:
      mLevelColor := color;
    BACKGROUND:
      mBackColor := color;
  end;
end;

procedure TMusicWave.setDirection(lft: boolean);
begin
  toLeft := lft;
end;

procedure TMusicWave.setSize(canvas: TCanvas; width, height: integer);
begin
  canvas.Brush.Color := clBlack;
  canvas.Pen.Color := clBlack;
  //canvas.Rectangle(x, y-mHeight, x+mWidth, y+1);
  mWidth := width; mHeight := height;
end;

procedure TMusicWave.showLevel(level: integer);
begin
  mLevel:=level;
  mShowLevel:=true;
end;

procedure TMusicWave.showWave(canvas: TCanvas; x, y, value: integer);
begin
  canvas.Brush.Color := clBlack;
  canvas.Pen.Color := clBlack;
  if (mPt = 0) then // first data coming
  begin
    prev := value;
    mPt := 1;
    canvas.Rectangle(x, y - mHeight, x + mWidth, y + 1);
    if (mShowLevel) then
    begin
      canvas.Pen.Color := clLime;
      canvas.MoveTo(x, y - mLevel);
      canvas.LineTo(x + mWidth, y - mLevel);
    end;
  end
  else
  begin
    if (toLeft) then
    begin
      canvas.CopyRect(Classes.Rect(x, y - mHeight, x + mWidth - dx, y + 1), canvas,
        Classes.Rect(x + dx, y - mHeight, x + mWidth, y + 1));
      canvas.Rectangle(x + mWidth - dx, y - mHeight, x + mWidth, y + 1);
      if (mShowLevel) then
      begin canvas.Pen.Color := clLime;
        canvas.MoveTo(x + mWidth - dx - 1, y - mLevel);
        canvas.LineTo(x + mWidth - 1, y - mLevel);
      end;
      canvas.Pen.Color := clYellow;
      canvas.MoveTo(x + mWidth - dx - 1, y - prev);
      canvas.LineTo(x + mWidth - 1, y - value);
    end
    else // moving to right
    begin
      canvas.CopyRect(Classes.Rect(x + dx - 1, y - mHeight, x + mWidth, y + 1), canvas,
        Classes.Rect(x - 1, y - mHeight, x + mWidth - dx, y + 1));
      canvas.Rectangle(x - 1, y - mHeight, x + dx, y + 1);
      if (mShowLevel) then
      begin
        canvas.Pen.Color := clLime;
        canvas.MoveTo(x + dx, y - mLevel);
        canvas.LineTo(x, y - mLevel);
      end;
      canvas.Pen.Color := clYellow;
      canvas.MoveTo(x + dx, y - prev);
      canvas.LineTo(x, y - value);
    end;
    prev := value;
  end;
end;


procedure TMusicBar.MusicBar( width,  height:integer);
begin
  mWidth:=width; mHeight:=height; mLevel:=0; down :=1;
end;

procedure TMusicBar.setSize(width, height: integer);
begin
  mWidth:=width; mHeight:=height ;
end;

procedure TMusicBar.showBar(canvas: TCanvas; px, py, value: integer);
var
  k, index: integer;
begin

  if (value >= mLevel) then
  begin
    mLevel := value;
    down := 0;
    top := 1;
  end
  else
  begin
    top := top + 1;
    if (top > 4) then down := 2; //down++;  // falling fast
    mLevel := mLevel - down;
    if (mLevel < 0) then mLevel := 0;
  end;
  canvas.Brush.Color := clBlack;
  canvas.Pen.Color := clBlack;
  canvas.Rectangle(px, py, px + mWidth, py - mHeight);
  if (value < 0) and (mLevel = 0) then
  begin
    canvas.Pen.Color := clWhite;
    canvas.MoveTo(px, py);
    canvas.LineTo(px + mWidth, py);
  end
  else
  begin
   //for (k := 0; k < value; k + := 2)
    k := 0;
    while (k < value) do
    begin canvas.Pen.Color := mColor[round((k shl 2) / mHeight)];
      canvas.MoveTo(px, py - k);
      canvas.LineTo(px + mWidth, py - k);
      k := k + 2;
    end;
  end;
  canvas.Pen.Color := clWhite;
  canvas.MoveTo(px, py - mLevel);
  canvas.LineTo(px + mWidth, py - mLevel);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  w, h, k: integer;
begin
  w := 7; h := 60;  // initial

  //for (int k:=0; k<BarNo; ++k)
  for k := 0 to BarNo do
  begin
    mbar[k].setSize(w, h);
    mbar[k].showBar(Form1.Canvas, 80 + (w + 1) * k, 150, random(h));
  end;
end;
//---------------------------------------------------------------------------

procedure TForm1.Button2Click(Sender: TObject);
begin
  if (Timer1.Enabled) then
    Button2.Caption := 'Timer Start'
  else
    Button2.Caption := 'Timer Stop';
  Timer1.Enabled := not Timer1.Enabled; // switch the timer state.
end;
//---------------------------------------------------------------------------

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Button1Click(nil);
  Button4Click(nil);
end;
//---------------------------------------------------------------------------

procedure TForm1.Button3Click(Sender: TObject);
begin
  mwave.showWave(Form1.Canvas, 250, 150, 20);
  mwave.showLevel(10);
end;
//---------------------------------------------------------------------------

procedure TForm1.Button4Click(Sender: TObject);
begin
  mwave.showWave(Form1.Canvas, 250, 150, random(49));

end;
//---------------------------------------------------------------------------


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  mwave.setDirection(CheckBox1.Checked);
end;
//---------------------------------------------------------------------------

procedure TForm1.Button5Click(Sender: TObject);
var
  dx, dy, x, ds, s: integer;
begin
  dx := 10; dy := 20; x := 0; ds := 4;  // integer
  //for (int s:=0; s<256; s+:=ds)
  s := 0;
  while (s < 256) do
  begin
    Form1.Canvas.Pen.Color := RGB(s, 255 - s, 0);
    Form1.Canvas.MoveTo(dx + x, dy);
    Form1.Canvas.LineTo(dx + x, dy + 20);
    x := x + 1;
    s := s + ds;
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i:integer;
begin
 for i:=low(mbar) to high(mbar) do
  begin
   mbar[i]:= TMusicBar.Create ;
   mbar[i].MusicBar(7,60);      // initialization
   mbar[i].mColor[0] := clLime;
   mbar[i].mColor[1] := clYellow;
   mbar[i].mColor[2] := clFuchsia;
   mbar[i].mColor[3] := clRed ;
   mbar[i].mColor[4] := clBlue ;

  end;
   
  mwave:= TMusicWave.Create ; //(200, 50)
  mwave.MusicWave(200,50); 
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i:integer;
begin
  for i:=low(mbar) to high(mbar) do
    mbar[i].Free;
  mwave.free;
end;

initialization

end.

